• hdu 1069 DAG加权


    题目:

    Monkey and Banana

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 13615    Accepted Submission(s): 7179


    Problem Description
    A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

    The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

    They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.

    Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
     
    Input
    The input file will contain one or more test cases. The first line of each test case contains an integer n,
    representing the number of different blocks in the following data set. The maximum value for n is 30.
    Each of the next n lines contains three integers representing the values xi, yi and zi.
    Input is terminated by a value of zero (0) for n.
     
    Output
    For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
     
    Sample Input
    1
    10 20 30
    2
    6 8 10
    5 5 5
    7
    1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7
    5
    31 41 59 26 53 58 97 93 23 84 62 64 33 83 27
    0
     
    Sample Output
    Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342
    大意是求DAG模型的最大高度,每个盒子有无限个,所以对盒子来说有三种可能的高度(长宽倒置不考虑);
    代码:

    #include<bits/stdc++.h>
    using namespace std;
    int dp[10005];
    struct C
    {
    int x,y;
    int height;
    };
    bool cmp(C a,C b)
    {
    return a.y<=b.y;
    }
    bool operator<(C a,C b)
    {
    if (a.x<b.x&&a.y<b.y) return 1;
    else if (a.x<b.y&&a.y<b.x) return 1;
    else return 0;
    }
    int main()
    {
    C B[10005];
    int a,b,c,i,j,maxn,n,k=0;
    while (cin>>n&&n){int p=-1;maxn=-1;k++;
    memset(dp,0,sizeof(dp));
    for (i=1;i<=n;i++){
    scanf("%d%d%d",&a,&b,&c);
    B[++p].x=min(a,b),B[p].y=max(a,b),B[p].height=c;
    B[++p].x=min(b,c),B[p].y=max(b,c),B[p].height=a;
    B[++p].x=min(a,c),B[p].y=max(a,c),B[p].height=b;

    }
    sort(B,B+p+1,cmp);

    for (i=0;i<=p;i++){int sumn=0;
    for (j=0;j<i;j++)
    {
    if (B[j]<B[i]&&dp[j]>sumn) sumn=dp[j];
    }
    dp[i]=sumn+B[i].height;
    maxn=max(maxn,dp[i]);
    }
    printf("Case %d: maximum height = %d ",k,maxn);

    }
    return 0;
    }

    基本就是N^2做法没啥好说的,排序把我坑了,应该只按照一条边来排序或者按S排序就ac,

    由于我是按两条边排的wa几次>_<

  • 相关阅读:
    学会辨识「漏洞炒作」你就比别人强!
    Java 18 正式发布
    致敬Gif之父,使用Java生成Gif图片
    easyes的出现,江湖不再需要RestHighLevelClient
    机器学习科普摘录一
    RedMonk最新编程语言排行榜;Spring 框架现 RCE 漏洞……|叨资讯
    你该不会也觉得Dubbo参数回调中callbacks属性是用来限制回调次数的吧?
    甲骨文严查Java许可问题;黑客的多合一黑客工具|叨资讯
    Runtime Inline Cache
    Arthas之类操作
  • 原文地址:https://www.cnblogs.com/zzqc/p/6413702.html
Copyright © 2020-2023  润新知